/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iOS Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			Michael Papp, San Francisco, CA, USA
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		S4BookTileLayer.m
 * Module:		Core
 * Library:		S4 iOS_UI Libraries
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import "S4BookTileLayer.h"


// ================================== Defines ==========================================

#define LEVELS_OF_DETAIL					(size_t)1
#define LEVELS_OF_DETAIL_BIAS				(size_t)3


// ================================== Typedefs ==========================================



// ================================== Globals ==========================================



// ============================= Forward Declarations ==================================



// ================================== Inlines ==========================================



// ========================= Begin Class S4BookTileLayer () ============================

@interface S4BookTileLayer ()

@end



// ========================== Begin Class S4BookTileLayer ==============================

@implementation S4BookTileLayer


//============================================================================
//	S4BookTileLayer synthesize properties
//============================================================================



//============================================================================
//	S4BookTileLayer :: init
//============================================================================
+ (CFTimeInterval)fadeDuration
{
	return (0.25);			// Set to 0.0 to disable fade
}


//============================================================================
//	S4BookTileLayer :: init
//============================================================================
- (id)init
{
	UIScreen						*mainScreen;
	CGFloat							screenScale;
	CGRect							screenBounds;
	CGFloat							w_pixels;
	CGFloat							h_pixels;
	CGFloat							widthOfTiles;
	CGFloat							heightOfTiles;

	self = [super init];
	if (nil != self)
	{
		self.levelsOfDetail = LEVELS_OF_DETAIL;
		self.levelsOfDetailBias = LEVELS_OF_DETAIL_BIAS;

		// get the device Screen, then bounds and scale
		mainScreen = [UIScreen mainScreen];
		screenBounds = [mainScreen bounds];
		screenScale = [mainScreen scale];

		// now calculate the width of the tiles
		w_pixels = (screenBounds.size.width * screenScale);
		if (512.0f > w_pixels)
		{
			widthOfTiles = 512.0f;
		}
		else
		{
			widthOfTiles = 1724.0f;
		}

		h_pixels = (screenBounds.size.height * screenScale);
		if (512.0f > h_pixels)
		{
			heightOfTiles = 512.0f;
		}
		else
		{
			heightOfTiles = 1424.0f;
		}
		self.tileSize = CGSizeMake(widthOfTiles, heightOfTiles);
	}
	return (self);
}


//============================================================================
//	S4BookTileLayer :: init
//============================================================================
- (void)dealloc
{
	[super dealloc];
}

@end
