/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iOS Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			Michael Papp, San Francisco, CA, USA
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		S4PdfBaseViewController.h
 * Module:		UI
 * Library:		S4 iOS_UI Libraries
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import "S4BaseDataViewController.h"


// =================================== Defines =========================================



// ================================== Typedefs =========================================



// ================================== Globals =========================================



// ============================= Forward Declarations =================================

@class S4PdfDocument;


// ================================== Protocols ========================================



// ======================== S4PdfBaseViewController Class ==============================

@interface S4PdfBaseViewController : S4BaseDataViewController
{
@protected
	S4PdfDocument									*m_pdfDocument;
	BOOL											m_bIsPrinting;
}

// Properties
@property (nonatomic, retain, readwrite) S4PdfDocument						*pdfDocument;

// Class methods

// Instance methods
- (id)init;
- (id)initWithNibName: (NSString *)nibName bundle: (NSBundle *)nibBundle;
- (void)displayPrintDialogFromButton: (UIBarButtonItem *)btn animated: (BOOL)animated showPageRange: (BOOL)pageRangeVisible;
- (void)displayPrintDialogFromRect: (CGRect)rect
							inView: (UIView *)containingView
						  animated: (BOOL)animated
					 showPageRange: (BOOL)pageRangeVisible;
- (void)handleWebURL: (NSURL *)url;

@end

