/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iOS Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			Michael Papp, San Francisco, CA, USA
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		S4PdfPage.h
 * Module:		UI
 * Library:		S4 iOS Libraries
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import "S4BookCachePage.h"


// =================================== Defines =========================================



// ================================== Typedefs =========================================


typedef enum
{
    LinkIsInvalid		= 0,
    LinkIsPageNumber	= 1,
	LinkIsURL			= 2,
	LinkTypeUnknown		= 3
} LinkTargetType;


// ================================== Globals =========================================



// ============================= Forward Declarations =================================

@class S4PdfDocument;


// ================================== Protocols ========================================



// =============================== S4PdfPage Class =====================================

@interface S4PdfPage : S4BookCachePage
{
}

// Properties

// Class methods

// Instance methods
- (BOOL)setImage: (CGImageRef)cgImage forPage: (NSUInteger)newPageIndex;
- (NSObject *)findLinkForViewPoint: (CGPoint)viewPoint
						inViewRect: (CGRect)pageRenderRect
					   linkTypePtr: (LinkTargetType *)linkType;
- (CGPoint)pdfPointFromViewPoint: (CGPoint)viewPoint inViewRect: (CGRect)pageRenderRect;
- (CGPoint)viewPointFromPDFPoint: (CGPoint)pdfPoint inViewRect: (CGRect)pageRenderRect;

@end
