/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iOS Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			Michael Papp, San Francisco, CA, USA
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		S4PdfUtilities.m
 * Module:		UI
 * Library:		S4 iOS_UI Libraries
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import "S4PdfUtilities.h"
#import "S4CommonDefines.h"


// ================================== Defines ==========================================



// ================================== Typedefs ==========================================



// ================================== Globals ==========================================



// ============================= Forward Declarations ==================================



// ================================== Inlines ==========================================



// ========================= Begin Class S4PdfUtilities () =============================

@interface S4PdfUtilities ()

@end



// ========================== Begin Class S4PdfUtilities ===============================

@implementation S4PdfUtilities


//============================================================================
//	S4PdfUtilities synthesize properties
//============================================================================



//============================================================================
//	S4PdfUtilities :: init
//============================================================================
/*
- (void) renderPageAtIndex: (NSUInteger)index inContext: (CGContextRef)context
{
	//If the view already contains a button control remove it
	if ([[self.view subviews] containsObject: button])
	{
		[button removeFromSuperview];
	}

	CGPDFPageRef page = CGPDFDocumentGetPage(pdf, index + 1);
	CGAffineTransform transform1 = aspectFit(CGPDFPageGetBoxRect(page, kCGPDFMediaBox), CGContextGetClipBoundingBox(context));
	CGContextConcatCTM(context, transform1);
	CGContextDrawPDFPage(context, page);


	CGPDFPageRef pageAd = CGPDFDocumentGetPage(pdf, index);

	CGPDFDictionaryRef pageDictionary = CGPDFPageGetDictionary(pageAd);

	CGPDFArrayRef outputArray;
	if ((true == CGPDFDictionaryGetArray(pageDictionary, "Annots", &outputArray)) && (NULL != outputArray))
	{
		size_t arrayCount = CGPDFArrayGetCount(outputArray);
		if (0 < arrayCount)
		{
			for (int j = 0; j < arrayCount; ++j)
			{
				CGPDFObjectRef aDictObj;
				if (false == CGPDFArrayGetObject(outputArray, j, &aDictObj))
				{
					continue;
				}

				CGPDFDictionaryRef annotDict;
				if (false == CGPDFObjectGetValue(aDictObj, kCGPDFObjectTypeDictionary, &annotDict))
				{
					continue;
				}

				CGPDFDictionaryRef aDict;
				if (false == CGPDFDictionaryGetDictionary(annotDict, "A", &aDict))
				{
					continue;
				}

				CGPDFStringRef uriStringRef;
				if (false == CGPDFDictionaryGetString(aDict, "URI", &uriStringRef))
				{
					continue;
				}

				CGPDFArrayRef rectArray;
				if (false == CGPDFDictionaryGetArray(annotDict, "Rect", &rectArray))
				{
					continue;
				}

				int arrayCount = CGPDFArrayGetCount(rectArray);
				CGPDFReal coords[4];
				int numCoords = 0;
				for (int k = 0; k < arrayCount, numCoords < 4; ++k)
				{
					CGPDFObjectRef rectObj;
					if (false == CGPDFArrayGetObject(rectArray, k, &rectObj))
					{
						continue;
					}

					CGPDFReal coord;
					if (false == CGPDFObjectGetValue(rectObj, kCGPDFObjectTypeReal, &coord))
					{
						continue;
					}

					coords[k] = coord;
					numCoords++;
				}

				if (4 != numCoords)
				{
					continue;
				}

				CGRect rect = CGRectMake(coords[0],coords[1],coords[2],coords[3]);

				CGPDFInteger pageRotate = 0;
				CGPDFDictionaryGetInteger(pageDictionary, "Rotate", &pageRotate); 
				CGRect pageRect = CGRectIntegral(CGPDFPageGetBoxRect(page, kCGPDFMediaBox));
				if (pageRotate == 90 || pageRotate == 270)
				{
					CGFloat temp = pageRect.size.width;
					pageRect.size.width = pageRect.size.height;
					pageRect.size.height = temp;
				}

				rect.size.width -= rect.origin.x;
				rect.size.height -= rect.origin.y;

				CGAffineTransform trans = CGAffineTransformIdentity;

//				trans = CGAffineTransformTranslate(trans, 0, pageRect.size.height);
//				trans = CGAffineTransformScale(trans, 1.0, -1.0);
				trans = CGAffineTransformTranslate(trans, 35, pageRect.size.height + 150);
				trans = CGAffineTransformScale(trans, 1.15, -1.15);

				rect = CGRectApplyAffineTransform(rect, trans);

//				char *uriString = (char *)CGPDFStringGetBytePtr(uriStringRef);
//				NSString *uri = [NSString stringWithCString:uriString encoding:NSUTF8StringEncoding];
				NSString *uri = (NSString *)CGPDFStringCopyTextString(uriStringRef);
				NSURL *urlLink = [[NSURL URLWithString: uri] retain];
				[uri release];
//				CGPDFContextSetURLForRect(context, (CFURLRef)urlLink, rect);

				//Create a button to get link actions
				UIButton *button = [[UIButton alloc] initWithFrame: rect];
//				[button setTitle: @"LINK" forState: UIControlStateNormal];
				[button setBackgroundImage: [UIImage imageNamed: @"link_bg.png"] forState: UIControlStateHighlighted];
				[button addTarget: self action: @selector(openLink:) forControlEvents: UIControlEventTouchUpInside];
				[self.view addSubview: button];
			}
		}
	}
	[leavesView reloadData];
}
*/


//============================================================================
//	S4PdfUtilities :: convertPDFDateStrToNSDate:
//============================================================================
+ (NSDate *)convertPDFDateStrToNSDate: (CGPDFStringRef)pdfDateStrRef
{
	NSString					*pdfFullDateStr;
	NSDateFormatter				*dateFormat;
	NSString					*formatCheck;
	NSString					*extract;
	NSDate						*dateResult = nil;

	if (NULL != pdfDateStrRef)
	{
		pdfFullDateStr = (NSString *)CGPDFStringCopyTextString(pdfDateStrRef);
		if (IS_NOT_NULL(pdfFullDateStr))
		{
			formatCheck = [pdfFullDateStr substringToIndex: 2];
			if (YES == [formatCheck isEqualToString: @"D:"])
			{
				dateFormat = [[NSDateFormatter alloc] init];
				extract = [pdfFullDateStr substringFromIndex: 2];
				if ([extract length] > 14)
				{
					[dateFormat setDateFormat: @"yyyyMMddHHmmssTZD"];
				}
				else 
				{
					[dateFormat setDateFormat: @"yyyyMMddHHmmss"];
				}
				dateResult = [dateFormat dateFromString: extract]; 
				[dateFormat release];
			}
			[pdfFullDateStr release];
		}
	}
	return (dateResult);
}



//##################################
// 'annot' CGPDFDictionary 'Rect' translate to objective c Rect
//##################################
/*
+ (BOOL)convertPDFRectInDictionary: (CGPDFDictionaryRef)annotDict toCGRect: (CGRect *)rect
{
	CGPDFArrayRef					rectArray;
	CGPDFReal						coords[4];

	if (true == CGPDFDictionaryGetArray(annotDict, "Rect", &rectArray))
	{
		int arrayCount = CGPDFArrayGetCount(rectArray);
		int numCoords = 0;
		for (int k = 0; k < arrayCount, numCoords < 4; ++k)
		{
			CGPDFObjectRef rectObj;
			if (false == CGPDFArrayGetObject(rectArray, k, &rectObj))
			{
				continue;
			}

			CGPDFReal coord;
			if (false == CGPDFObjectGetValue(rectObj, kCGPDFObjectTypeReal, &coord))
			{
				continue;
			}

			coords[k] = coord;
			numCoords++;
		}
		
		if (4 == numCoords)
		{
			CGRect tmpRect = CGRectMake(coords[0],coords[1],coords[2],coords[3]);
			
			CGPDFInteger pageRotate = 0;
			CGPDFDictionaryGetInteger(pageDictionary, "Rotate", &pageRotate); 
			CGRect pageRect = CGRectIntegral(CGPDFPageGetBoxRect(page, kCGPDFMediaBox));
			if (pageRotate == 90 || pageRotate == 270)
			{
				CGFloat temp = pageRect.size.width;
				pageRect.size.width = pageRect.size.height;
				pageRect.size.height = temp;
			}
			
			tmpRect.size.width -= tmpRect.origin.x;
			tmpRect.size.height -= tmpRect.origin.y;
			
			CGAffineTransform trans = CGAffineTransformIdentity;
			
//			trans = CGAffineTransformTranslate(trans, 0, pageRect.size.height);
//			trans = CGAffineTransformScale(trans, 1.0, -1.0);
			trans = CGAffineTransformTranslate(trans, 35, pageRect.size.height + 150);
			trans = CGAffineTransformScale(trans, 1.15, -1.15);
			
			tmpRect = CGRectApplyAffineTransform(tmpRect, trans);
		}
	}
	return (bResult);
}
*/

@end











