/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iOS Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2011
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			Michael Papp, San Francisco, CA, USA
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		S4PageCurlPdfModel.m
 * Module:		UI
 * Library:		S4 iOS_UI Libraries
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import "S4PageCurlPdfModel.h"
#import "S4PdfDataViewController.h"
#import "S4PdfDocument.h"
#import "S4CommonDefines.h"


// ================================== Defines ==========================================



// ================================== Typedefs ==========================================



// ================================== Globals ==========================================



// ============================= Forward Declarations ==================================



// ================================== Inlines ==========================================




// ======================= Begin Class S4PageCurlPdfModel () ===========================

@interface S4PageCurlPdfModel ()

@end



// ======================== Begin Class S4PageCurlPdfModel =============================

@implementation S4PageCurlPdfModel


//============================================================================
//	S4PageCurlPdfModel synthesize properties
//============================================================================



//============================================================================
//	S4PageCurlPdfModel :: init
//============================================================================
- (id)init
{
    self = [super init];
    if (nil != self)
	{
    }
    return self;
}


//============================================================================
//	S4PageCurlPdfModel :: dealloc
//============================================================================
- (void)dealloc
{
	[super dealloc];
}


//============================================================================
//	S4PageCurlPdfModel :: viewControllerAtIndex:
//============================================================================
- (S4PdfDataViewController *)viewControllerAtIndex: (NSUInteger)index
{
	NSUInteger							pdfPageIndex;
	S4PdfDocument						*pdfDocument;
	S4PdfDataViewController				*dataViewController = nil;

	pdfPageIndex = index + 1;
	pdfDocument = (S4PdfDocument *)self.dataSource;
	if (pdfDocument.pageCount >= pdfPageIndex)
	{
		dataViewController = (S4PdfDataViewController *)[self cachedViewControllerForIndex: index];
		if (IS_NULL(dataViewController))
		{
			dataViewController = [[S4PdfDataViewController alloc] initWithNibName: nil bundle: nil];
			dataViewController.pdfDocument = pdfDocument;
			dataViewController.indexOfViewController = index;
			[self cacheViewController: dataViewController];
		}
	}
	return (dataViewController);
}


//============================================================================
//	S4PageCurlPdfModel :: indexOfViewController:
//============================================================================
- (NSUInteger)indexOfViewController: (S4PdfDataViewController *)viewController
{   
	return (viewController.indexOfViewController);
}


//============================================================================
//	S4PageCurlPdfModel :: pageCount
//============================================================================
- (NSUInteger)pageCount
{
	S4PdfDocument					*pdfDocument;

	pdfDocument = (S4PdfDocument *)self.dataSource;
	return (pdfDocument.pageCount);
}

@end
