//
//  ExampleViewController.m
//  Leaves
//
//  Created by Tom Brow on 4/18/10.
//  Copyright 2010 Tom Brow. All rights reserved.
//


#import "ImageExampleViewController.h"
#import "S4BookViewUtilities.h"



@implementation ImageExampleViewController

- (id)init
{
	self = [super init];
    if (nil != self)
	{
		images = [[NSArray alloc] initWithObjects:
				  [UIImage imageNamed:@"kitten.jpg"],
				  [UIImage imageNamed:@"kitten2.jpg"],
				  [UIImage imageNamed:@"kitten3.jpg"],
				  nil];
    }
    return self;
}


- (void)dealloc
{
	[images release];

    [super dealloc];
}


- (void)viewDidLoad
{
	[super viewDidLoad];

	m_genericBookView.dataSource = self;
}



#pragma mark S4BookViewDataSource methods

- (NSUInteger)pageCount
{
	return images.count;
}


- (void)renderPageAtIndex: (NSUInteger)index inContext: (CGContextRef)ctx
{
	if ([self pageCount] > index)
	{
		UIImage *image = [images objectAtIndex:index];
		CGRect imageRect = CGRectMake(0, 0, image.size.width, image.size.height);
		CGAffineTransform transform = aspectFit(imageRect, CGContextGetClipBoundingBox(ctx));
		CGContextConcatCTM(ctx, transform);
		CGContextDrawImage(ctx, imageRect, [image CGImage]);
	}
}

@end
