//
//  OverlayView.h
//  oKnow
//
//  Created by Robert Simpson on 8/1/10.
//  Copyright 2010 Accilent Corp. All rights reserved.
//

#import <UIKit/UIKit.h>

@class S4GenericBookView;

/**
 * <p>Usage:
 * </p>
 *
 * <p>in ...ViewController.h:
 * </p>
 * <xmp>
 *
 *    IBOutlet OverlayView * overlayView;
 *
 * </xmp>
 * <p>If using a NIB, connect the view outlet of the File's Owner to the UIView and connect
 *    the overlayView outlet to a view with Class OverlayView in the Identity Inspector.
 * </p>
 *
 * <p>in ...ViewController.m viewDidLoad:
 * </p>
 * <xmp>
 *
 *    [OverlayView addOverlayView:overlayView onView:self.view];
 *
 * </xmp>
 * </p>
**/

@interface OverlayView : UIView
{
/**
 * <p>The S4GenericBookViewController gives us access to the S4GenericBookView,
 *    since the S4GenericBookView itself is not available to Interface Builder.
 * </p>
**/

   S4GenericBookView					*m_bookView;
   BOOL									touchesBeganInLeavesView;

}

@property (nonatomic, retain) S4GenericBookView						*bookView;

+ (void)addOverlayView: (OverlayView *)overlayView onView: (UIView *)view;

@end
