//
//  S4PageCurlDemoModel.m
//  page_app
//
//  Created by Michael Papp on 8/28/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//


#import "S4PageCurlDemoModel.h"
#import "S4PageCurlDemoViewController.h"
#import "S4CommonDefines.h"




@interface S4PageCurlDemoModel ()

@property (readonly, strong, nonatomic) NSArray *pageData;

@end




@implementation S4PageCurlDemoModel

@synthesize pageData = _pageData;

- (id)init
{
    self = [super init];
    if (self)
	{
		// Create the data model.
		NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
		_pageData = [[dateFormatter monthSymbols] copy];
    }
    return self;
}

- (S4PageCurlDemoViewController *)viewControllerAtIndex:(NSUInteger)index
{   
    // Return the data view controller for the given index.
    if (([self.pageData count] == 0) || (index >= [self.pageData count]))
	{
        return nil;
    }
    
    // Create a new view controller and pass suitable data.
    S4PageCurlDemoViewController *dataViewController;

	dataViewController = (S4PageCurlDemoViewController *)[self cachedViewControllerForIndex: index];
	if (IS_NULL(dataViewController))
	{
		if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone)
		{
			dataViewController = [[S4PageCurlDemoViewController alloc] initWithNibName:@"S4DataViewController_iPhone" bundle:nil];
		}
		else
		{
			dataViewController = [[S4PageCurlDemoViewController alloc] initWithNibName:@"S4DataViewController_iPad" bundle:nil];
		}
		dataViewController.dataObject = [self.pageData objectAtIndex: index];
		dataViewController.indexOfViewController = index;
		[self cacheViewController: dataViewController];
	}
    return dataViewController;
}

- (NSUInteger)indexOfViewController:(S4PageCurlDemoViewController *)viewController
{   
    /*
     Return the index of the given data view controller.
     For simplicity, this implementation uses a static array of model objects and the view controller stores the model object; you can therefore use the model object to identify the index.
     */
    return [self.pageData indexOfObject:viewController.dataObject];
}


- (NSUInteger)pageCount
{
	return ([self.pageData count]);
}


@end
