/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iOS Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2012
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			Michael Papp, San Francisco, CA, USA
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		S4GCDUtilities.h
 * Module:		Application
 * Library:		S4 iOS Libraries
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import <Foundation/Foundation.h>


// =================================== Defines =========================================

#define GLOBAL_GCD_QUEUE_PRIORITY_HIGH				dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_HIGH, 0ul);
#define GLOBAL_GCD_QUEUE_PRIORITY_DEFAULT			dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0ul);
#define GLOBAL_GCD_QUEUE_PRIORITY_LOW				dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_LOW, 0ul);
#define GLOBAL_GCD_QUEUE_PRIORITY_BACKGROUND		dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_BACKGROUND, 0ul);
#define MAIN_THREAD_GCD_QUEUE						dispatch_get_main_queue(void);


// ================================== Typedefs =========================================



// =================================== Globals =========================================



// ============================= Forward Declarations ==================================



// ================================== Protocols ========================================



// ============================= Class S4GCDUtilities ==================================

@interface S4GCDUtilities : NSObject
{
}

// Class methods
+ (S4GCDUtilities *)singleton;

// convenience method to convert an NSOperationQueuePriority value to an equivalent dispatch queue
+ (dispatch_queue_t)globalDispatchQueueFromNSOperationQueuePriority: (NSOperationQueuePriority)priority;

// Instance methods

// create a private dispatch queue; release it with the dispatch_release function
- (dispatch_queue_t)createPrivateGCDQueueWithIntLabel: (NSUInteger)labelUInteger isSerial: (BOOL)bSerial;

@end
