/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iOS Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2012
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			Michael Papp, San Francisco, CA, USA
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		S4OverlayViewController.h
 * Module:		UI
 * Library:		S4 iOS UI Libraries
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>


// =================================== Defines =========================================



// ================================== Typedefs =========================================

typedef NS_ENUM(NSUInteger, S4OverlayVCStyles)
{
	kBackgroundClear		= 0,
	kBackgroundBlack		= 1,
	kBackgroundGradient		= 2
};


// =================================== Globals =========================================



// ============================= Forward Declarations ==================================



// ================================== Protocols ========================================



// =========================== Class S4OverlayViewController ===========================

@interface S4OverlayViewController : UIViewController
{
}

// Properties
@property (readonly, assign, nonatomic) BOOL						visible;

// Class methods
+ (S4OverlayViewController *)singleton;

// Instance methods
- (void)showWithMessage: (NSString *)msgString
		withOverlayMode: (S4OverlayVCStyles)overlayMode
   allowUserInteraction: (BOOL)userInteractionEnabled;

- (void)setMessage: (NSString *)msgString;

- (void)dismissOverlayWithMessage: (NSString *)msgString
							image: (UIImage *)imageToDisplay
					   afterDelay: (NSTimeInterval)seconds;

- (void)dismissOverlay;

@end
