/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iOS Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2012
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			unknown - many sources
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		S4PageControl.h
 * Module:		UI
 * Library:		S4 iOS Libraries
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>


// =================================== Defines =========================================



// ================================== Typedefs =========================================



// =================================== Globals =========================================



// ============================= Forward Declarations ==================================



// ================================== Protocols ========================================



// ============================= Class S4PageControl ===================================

@interface S4PageControl : UIControl
{
}

//	Properties
@property (nonatomic, assign) NSInteger						currentPage;
@property (nonatomic, assign) NSInteger						numberOfPages;
@property (nonatomic, assign) BOOL							defersCurrentPageDisplay;
@property (nonatomic, assign) BOOL							hidesForSinglePage;
@property (nonatomic, assign) BOOL							wrap;
@property (nonatomic, strong) UIColor						*defaultDotColor;
@property (nonatomic, strong) UIColor						*selectedDotColor;
@property (nonatomic, strong) UIColor						*highlightedDotColor;
@property (nonatomic, assign) CGFloat						dotSpacing;
@property (nonatomic, assign) CGFloat						dotSize;
@property (nonatomic, assign) BOOL							shouldEnableHighlight;


//	Instance methods
- (CGSize)sizeForNumberOfPages: (NSInteger)pageCount;
- (void)updateCurrentPageDisplay;

@end
