//
//  PerfTest.m
//  YAJL
//
//  Created by Gabriel Handford on 6/29/09.
//  Copyright 2009. All rights reserved.
//



@interface PerfTest : YAJLTestCase {}
@end

@implementation PerfTest

#define kPerfTestCount 200

- (void)_testS4JSONParser {
  NSString *examplePath = [[NSBundle mainBundle] pathForResource:@"sample" ofType:@"json"];
  NSData *data = [[NSData dataWithContentsOfFile:examplePath options:NSUncachedRead error:nil] retain]; 
  
  NSTimeInterval start = [NSDate timeIntervalSinceReferenceDate];
  for(NSInteger i = 0; i < kPerfTestCount; i++) {
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    S4YajlParser *parser = [[S4YajlParser alloc] initWithParserOptions:S4JSONParserOptionsNone];
    if (![parser parse:data]) GHFail(@"Failed to parse: %@", parser.parserError);   
    [parser release];
    [pool release];
  }
  NSTimeInterval took = [NSDate timeIntervalSinceReferenceDate] - start;
  GHTestLog(@"Took %0.4f sec", took);
  [data release];
}

@end
