//
//  S4JSONFileTest.m
//  YAJL
//
//  Created by Gabriel Handford on 3/1/09.
//  Copyright 2009. All rights reserved.
//


@interface S4JSONFileTest : YAJLTestCase {}
@end

@implementation S4JSONFileTest

- (S4YajlJSONFile *)_loadDocument:(NSString *)sampleName parserOptions:(S4JSONParserOptions)parserOptions error:(NSError **)error {
  NSData *data = [self loadData:sampleName];
	S4YajlJSONFile *file = [[[S4YajlJSONFile alloc] initWithParserOptions: parserOptions] autorelease];
	[file parseData: data error: error];
  return file;
}

- (void)test
{    
  NSError *error = nil;
  S4YajlJSONFile *file = [self _loadDocument:@"example" parserOptions:0 error:&error];
  if (error) GHFail(@"Error: %@", error);
  GHTestLog(@"Root: %@", file.rootJSONObject);
}

- (void)testDoubleOverflow
{
	NSError *error = nil;

	NSData *data = [self loadData: @"overflow"];
	S4YajlJSONFile *file = [[[S4YajlJSONFile alloc] initWithParserOptions: 0] autorelease];
	[file parseData: data error: &error];
	GHAssertNotNil(file, nil);
	GHTestLog(@"Root: %@", file.rootJSONObject);
//	GHAssertEquals(status, S4JSONParserCanceledError, @"Should have error status");
  
	if (error)
	{
		GHTestLog(@"Parse error:\n%@", error);
		GHAssertEquals([error code], (NSInteger)S4JSONParserCanceledError, nil);
	}
	else
	{
		GHFail(@"Should have error");
	}
}

- (void)testOverflow2
{
  NSError *error = nil;

	S4YajlJSONFile *file = [self _loadDocument: @"overflow2" parserOptions: 0 error: &error];
	if (error)
	{
		GHFail(@"Should have passed");
	}
	else
	{
		GHTestLog(@"Root: %@", file.rootJSONObject);
		GHAssertEqualObjects([(NSDictionary *)file.rootJSONObject objectForKey:@"key1"], [NSNumber numberWithDouble:12343434343434343434343434344343434.0], nil);
		GHAssertEqualObjects([(NSDictionary *)file.rootJSONObject objectForKey:@"key2"], [NSNumber numberWithDouble:343434343434344343434343434.0], nil);
	}
}


@end
