//
//  UIControl-BKAdditions.m
//  BlockKit
//
//  Created by Nick Paulson on 7/16/11.
//


#import "UIControl-BKAdditions.h"
#import "BKVoidBlockWrapper.h"
#import "NSObject-BKAdditions.h"




@implementation UIControl (BKAdditions)


- (void)addActionForControlEvents: (UIControlEvents)controlEvents usingBlock: (BKVoidBlock)block
{
	BKVoidBlockWrapper					*blockWrapper;

	blockWrapper = [[BKVoidBlockWrapper alloc] initWithBlock: block userInfo: [NSNumber numberWithInteger: controlEvents]];
	[self addTarget: blockWrapper action: @selector(performBlock) forControlEvents: controlEvents];
}


- (void)removeAllActionBlocks;
{
	@autoreleasepool
	{
		NSArray *targets = [[self.allTargets copy] autorelease];

		for (id currTarget in targets)
		{
			if ([currTarget isKindOfClass: [BKVoidBlockWrapper class]])
			{
				UIControlEvents controlEvents = [[(BKVoidBlockWrapper *)currTarget userInfo] integerValue];
				[self removeTarget: currTarget action: @selector(performBlock) forControlEvents: controlEvents];
				[currTarget release];
			}
		}
    }
}

@end
