//
//  CMyDefaults.m
//  Test
//
//  Created by Jonathan Wight on 10/3/11.
//  Copyright (c) 2011 toxicsoftware.com. All rights reserved.
//


#import "CMyDefaults.h"
#import "CPropertyFactory.h"



@interface CMyDefaults ()

@property (readwrite, atomic, strong) NSMutableDictionary		*storage;

@end



@implementation CMyDefaults
{
	NSMutableDictionary				*m_backingStore;
}


@dynamic name;
@dynamic timestamp;
@dynamic position;
@dynamic yorn;
@dynamic floating;
@dynamic lulah;
@dynamic range;
@dynamic ptr;
@dynamic error;

@synthesize storage = m_backingStore;



+ (void)initialize
{
    if (self == [CMyDefaults class])
	{
		@autoreleasepool
		{
			CPropertyFactory		*propFactory;
			BOOL					result;
			NSError					*error;

			PropertyGetterBlock theGetter = ^(id _self, NSString *key) {
				if ((nil != key) && (![key isEqual: [NSNull null]]))
				{
					return ([((CMyDefaults *)_self).storage objectForKey: key]);
				}
				return ((id)nil);
			};

			PropertySetterBlock theSetter = ^(id _self, NSString *key, id value) {
				if ((nil != key) && (![key isEqual: [NSNull null]]) && (nil != value) && ([value isKindOfClass:[NSObject class]]))
				{
					[((CMyDefaults *)_self).storage setObject: value forKey: key];
				}
			};

			propFactory = [[CPropertyFactory alloc] init];
			if (nil != propFactory)
			{
				result = [propFactory configure: self getter: theGetter setter: theSetter error: &error];
				if (NO == result)
				{
					NSLog(@"CMyDefaults failed in initialize");
				}
			}
		}
	}
}


- (id)init
{
	self = [super init];
    if (nil != self)
	{
        self.storage = [NSMutableDictionary dictionary];
	}
    return self;
}

@end
