//
//  main.m
//  Test
//
//  Created by Jonathan Wight on 10/3/11.
//  Copyright (c) 2011 toxicsoftware.com. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "CMyDefaults.h"
#import "NSUserDefaults+Test.h"

int main (int argc, const char * argv[])
{
    @autoreleasepool
	{
        CMyDefaults *theDefaults = [[CMyDefaults alloc] init];;

        theDefaults.name = @"This is a test";
        NSLog(@"%@", theDefaults.name);

        theDefaults.timestamp = 42;
		NSLog(@"Meaning of life: %g", theDefaults.timestamp);

        theDefaults.yorn = YES;
        NSLog(@"%d", theDefaults.yorn);

        theDefaults.position = (NSPoint){ 10, 20 };
        NSLog(@"%@", NSStringFromPoint(theDefaults.position));

		theDefaults.floating = 0.012;
		NSLog(@"%f", theDefaults.floating);

		theDefaults.lulah = LONG_LONG_MAX;
		NSLog(@"%lld", theDefaults.lulah);
	
		theDefaults.range = (NSRange){ 0, LONG_MAX };
		NSLog(@"%@", NSStringFromRange(theDefaults.range));

		theDefaults.ptr = (void *)256;
		NSLog(@"%p", theDefaults.ptr);

		NSMutableDictionary	*userDict = [NSMutableDictionary dictionaryWithCapacity: 2];
		[userDict setObject: @"this is the error" forKey: NSLocalizedDescriptionKey];
		[userDict setObject: @"for testing" forKey: NSLocalizedFailureReasonErrorKey];
		// create the NSError
		theDefaults.error = [NSError errorWithDomain: @"myDomain" code: 0 userInfo: userDict];
		NSLog(@"%@", theDefaults.error);
	}
    return 0;
}

