/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the S4 iPhone Libraries.
 *
 * The Initial Developer of the Original Code is
 * Michael Papp dba SeaStones Software Company.
 * All software created by the Initial Developer are Copyright (C) 2008-2009
 * the Initial Developer. All Rights Reserved.
 *
 * Original Author:
 *			Michael Papp, San Francisco, CA, USA
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** FILE BLOCK ******
 *
 * Name:		SHKDefaultAppSettingsDelegate.m
 * Module:		Configuration
 * Library:		ShareKit
 *
 * ***** FILE BLOCK *****/


// ================================== Includes =========================================

#import "SHKDefaultAppSettingsDelegate.h"


// =================================== Defines =========================================



// ================================== Typedefs =========================================



// =================================== Globals =========================================



// ============================= Forward Declarations ==================================



// ================================== Inlines ==========================================



// ================= Begin Class SHKDefaultAppSettingsDelegate () ======================



// ============= Begin Class SHKDefaultAppSettingsDelegate (PrivateImpl) ===============




// ===================== Begin Class SHKDefaultAppSettingsDelegate =====================


@implementation SHKDefaultAppSettingsDelegate


- (NSString *)appName
{
	return @"My App Name";
}


- (NSString *)appURL
{
	return @"http://example.com";
}


- (NSString *)posterousAPIKey
{
	return (nil);
}


- (NSString *)deliciousConsumerKey
{
	return (nil);
}


- (NSString *)deliciousSecretKey
{
	return (nil);
}


- (NSString *)readItLaterKey
{
	return (nil);
}


- (NSString *)evernoteUserStoreURL
{
	return (nil);
}


- (NSString *)evernoteSecretKey
{
	return (nil);
}


- (NSString *)evernoteConsumerKey
{
	return (nil);
}


- (NSString *)evernoteNetStoreURLBase
{
	return (nil);
}


- (NSString *)bitLyLogin
{
	return (nil);
}


- (NSString *)bitLyKey
{
	return (nil);
}


- (NSString *)flickrConsumerKey
{
	return (nil);
}


- (NSString *)flickrSecretKey
{
	return (nil);
}


- (NSString *)flickrCallbackUrl{
	return (nil);
}


- (NSString *)facebookAppId
{
	return (nil);
}


- (NSString *)facebookSecret
{
	return (nil);
}


- (NSNumber *)openURLsInExternalBrowser
{
	return ([NSNumber numberWithBool: YES]);
}


- (NSString *)twitterConsumerKey
{
	return (nil);
}


- (NSString *)twitterSecret
{
	return (nil);
}


- (NSString *)twitterCallbackUrl
{
	return (nil);
}


- (NSNumber *)twitterUseXAuth
{
	return [NSNumber numberWithBool: NO];
}


- (NSString *)twitterUsername
{
	return (nil);
}


- (NSString *)barStyle
{
	return (@"UIBarStyleDefault");
}


- (NSNumber *)barTintColorRed
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSNumber *)barTintColorGreen
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSNumber *)barTintColorBlue
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSNumber *)formFontColorRed
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSNumber *)formFontColorGreen
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSNumber *)formFontColorBlue
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSNumber *)formBgColorRed
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSNumber *)formBgColorGreen
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSNumber *)formBgColorBlue
{
	return ([NSNumber numberWithInt: -1]);
}


- (NSString *)modalPresentationStyle
{
	return (@"UIModalPresentationFormSheet");
}

- (NSString *)modalTransitionStyle
{
	return (@"UIModalTransitionStyleCoverVertical");
}


- (NSNumber *)shareMenuAlphabeticalOrder
{
	return ([NSNumber numberWithBool: YES]);
}


- (NSNumber *)sharedWithSignature
{
	return ([NSNumber numberWithBool: NO]);
}


- (NSString *)sharersPlistName
{
	return (@"SHKSharers.plist");
}


- (NSNumber *)maxFavCount
{
	return ([NSNumber numberWithInt: 3]);
}


- (NSString *)favsPrefixKey
{
	return (@"SHK_FAVS_");
}


- (NSString *)authPrefix
{
	return (@"SHK_AUTH_");
}


- (NSNumber *)allowOffline
{
	return ([NSNumber numberWithBool: YES]);
}

@end
